src/Entity/Components.php
<?php

namespace App\Entity;

use App\Repository\ComponentsRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Mapping\ClassMetadata;


/**
 * @ORM\Entity(repositoryClass=ComponentsRepository::class)
 * @ORM\Entity
 * @ORM\InheritanceType("SINGLE_TABLE")
 * @ORM\DiscriminatorColumn(name="discr", type="string")
 */
class Components
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $Type;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $Name;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $Url;

    /**
     * @ORM\Column(type="decimal", precision=10, scale=0, nullable=true)
     */
    private $Price;

    /**
     * @ORM\Column(type="decimal", precision=10, scale=0, nullable=true)
     */
    private $Frequency;

    /**
     * @ORM\Column(type="decimal", precision=10, scale=0, nullable=true)
     */
    private $Power;

    /**
     * @ORM\Column(type="decimal", precision=10, scale=0, nullable=true)
     */
    private $Pcies;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $Socket;

    /**
     * @ORM\Column(type="decimal", precision=10, scale=0, nullable=true)
     */
    private $Size;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $img;

    

    

    
    public function getId(): ?int
    {
        return $this->id;
    }

    public function getType(): ?string
    {
        return $this->Type;
    }

    public function setType(string $Type): self
    {
        $this->Type = $Type;

        return $this;
    }

    public function getName(): ?string
    {
        return $this->Name;
    }

    public function setName(string $Name): self
    {
        $this->Name = $Name;

        return $this;
    }

    public function getUrl(): ?string
    {
        return $this->Url;
    }

    public function setUrl(string $Url): self
    {
        $this->Url = $Url;

        return $this;
    }

    public function getPrice(): ?string
    {
        return $this->Price;
    }

    public function setPrice(?string $Price): self
    {
        $this->Price = $Price;

        return $this;
    }

    public function getFrequency(): ?string
    {
        return $this->Frequency;
    }

    public function setFrequency(?string $Frequency): self
    {
        $this->Frequency = $Frequency;

        return $this;
    }

    public function getPower(): ?string
    {
        return $this->Power;
    }

    public function setPower(?string $Power): self
    {
        $this->Power = $Power;

        return $this;
    }

    public function getPcies(): ?string
    {
        return $this->Pcies;
    }

    public function setPcies(?string $Pcies): self
    {
        $this->Pcies = $Pcies;

        return $this;
    }

    public function getSocket(): ?string
    {
        return $this->Socket;
    }

    public function setSocket(?string $Socket): self
    {
        $this->Socket = $Socket;

        return $this;
    }

    public function getSize(): ?string
    {
        return $this->Size;
    }

    public function setSize(?string $Size): self
    {
        $this->Size = $Size;

        return $this;
    }

    

    public function __toString(): string
    {
        return $this->Name;
    }

    public function getImg(): ?string
    {
        return $this->img;
    }

    public function setImg(?string $img): self
    {
        $this->img = $img;

        return $this;
    }

}

src/Form/ComponentsType.php
<?php

namespace App\Form;

use App\Entity\Components;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;

class ComponentsType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('Type', ChoiceType::class, [
                'choices' => [
                    'Gpu' => 'Gpu',
                    'Cpu' => 'Cpu',
                    'Ram' => 'Ram',
                    'Storage' => 'Storage',
                    'Motherboard' => 'Motherboard',
                    'Powersupply' => 'Powersupply',
                    'Accessory' => 'Accessory',
                    'Rig' => 'Rig',

                ],
            ])
            ->add('Name')
            ->add('Url')

            ->add('Price',  null, [
                'required'   => false,
                'empty_data' => '0',
            ])

            ->add('Size',  null, [
                'required'   => false,
                'empty_data' => '0',
            ])

            ->add('Frequency',  null, [
                'required'   => false,
                'empty_data' => '0',
            ])

            ->add('Power',  null, [
                'required'   => false,
                'empty_data' => '0',
            ])

            ->add('Pcies',  null, [
                'required'   => false,
                'empty_data' => '0',
            ])

            ->add('Socket',  null, [
                'required'   => false,
                'empty_data' => '0',
            ])

            ->add('Img',  null, [
                'required'   => false,
                'empty_data' => '0',
            ])
        ;
    }

    // public function configureOptions(OptionsResolver $resolver)
    // {
    //     $resolver->setDefaults([
    //         'data_class' => Components::class,
    //     ]);
    // }
}

src/Controller/Components/AccesoiresController.php
<?php

namespace App\Controller\Components;

use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use App\Entity\Components;

class AccesoiresController extends AbstractController
{
    /**
     * @Route("/component/accesoires", name="accesoires")
     */

    public function index(): Response
    {
        $Components = $this->getDoctrine()->getRepository(Components::class)->findBy([],['id' => 'asc']);

       
        return $this->render('Components/accessoires.html.twig', compact('Components'));
        
    }
}

src/Controller/Components/AllimentationsController.php
<?php

namespace App\Controller\Components;

use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use App\Entity\Components;

class AllimentationsController extends AbstractController
{
    /**
     * @Route("/component/allimentations", name="allimentations")
     */
    
    public function index(): Response
    {
        $Components = $this->getDoctrine()->getRepository(Components::class)->findBy([],['id' => 'asc']);

       
        return $this->render('Components/allimentations.html.twig', compact('Components'));
        
    }
}

src/Controller/Components/CarteMereController.php
<?php

namespace App\Controller\Components;


use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use App\Entity\Components;

class CarteMereController extends AbstractController
{
    /**
     * @Route("/component/cartemere", name="carte_mere")
     */
    

    public function index(): Response
    {
        $Components = $this->getDoctrine()->getRepository(Components::class)->findBy([],['id' => 'asc']);

       
        return $this->render('Components/cartesmere.html.twig', compact('Components'));
        
    }
}

src/Controller/Components/CartesGraphiquesController.php
<?php

namespace App\Controller\Components;

use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

class CartesGraphiquesController extends AbstractController
{
    /**
     * @Route("/component/cartes_graphiques", name="cartes_graphiques")
     */
 
    public function index(): Response
    {
        $Components = $this->getDoctrine()->getRepository(Components::class)->findBy([],['id' => 'asc']);

       
        return $this->render('Components/cartesgraphiques.html.twig', compact('Components'));
        
    }
}

src/Controller/Components/ProcesseurController.php
<?php

namespace App\Controller\Components;

use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use App\Entity\Components;

class ProcesseurController extends AbstractController
{
    /**
     * @Route("/component/processeur", name="processeur")
     */
 
    public function index(): Response
    {
        $Components = $this->getDoctrine()->getRepository(Components::class)->findBy([],['id' => 'asc']);

       
        return $this->render('Components/processeur.html.twig', compact('Components'));
        
    }
}

src/Controller/Components/RamController.php
<?php

namespace App\Controller\Components;

use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use App\Entity\Components;

class RamController extends AbstractController
{
    /**
     * @Route("component/ram", name="ram")
     */
    public function index(): Response
    {
        $Components = $this->getDoctrine()->getRepository(Components::class)->findBy([],['id' => 'asc']);

       
        return $this->render('Components/ram.html.twig', compact('Components'));
        
    }
}

src/Controller/Components/RigController.php
<?php

namespace App\Controller\Components;

use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use App\Entity\Components;

class RigController extends AbstractController
{
    /**
     * @Route("/component/rig", name="rig")
     */
    public function index(): Response
    {
        $Components = $this->getDoctrine()->getRepository(Components::class)->findBy([],['id' => 'asc']);

       
        return $this->render('Components/rig.html.twig', compact('Components'));
        
    }
}

src/Controller/Components/StockageController.php
<?php

namespace App\Controller\Components;

use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use App\Entity\Components;

class StockageController extends AbstractController
{
    /**
     * @Route("/component/stockage", name="stockage")
     */
    public function index(): Response
    {
        $Components = $this->getDoctrine()->getRepository(Components::class)->findBy([],['id' => 'asc']);

       
        return $this->render('Components/stockage.html.twig', compact('Components'));
        
    }
}

src/Controller/ComponentsController.php
<?php

namespace App\Controller;

use App\Entity\Components;
use App\Form\ComponentsType;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\IsGranted;

/**
 * @Route("/components")
 * Require ROLE_ADMIN for *every* controller method in this class.
 * @IsGranted("ROLE_ADMIN" )
 */
class ComponentsController extends AbstractController
{
    /**
     * @Route("/", name="components_index", methods={"GET"})
     */
    public function index(): Response
    {
        $components = $this->getDoctrine()
            ->getRepository(Components::class)
            ->findAll();

        return $this->render('components/index.html.twig', [
            'components' => $components,
        ]);
    }

    /**
     * @Route("/new", name="components_new", methods={"GET","POST"})
     */
    public function new(Request $request): Response
    {
        $component = new Components();
        $form = $this->createForm(ComponentsType::class, $component);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $entityManager = $this->getDoctrine()->getManager();
            $entityManager->persist($component);
            $entityManager->flush();

            return $this->redirectToRoute('components_index', [], Response::HTTP_SEE_OTHER);
        }

        //dd($component);
        return $this->renderForm('components/new.html.twig', [
            'component' => $component,
            'form' => $form,
        ]);
    }

    /**
     * @Route("/{id}", name="components_show", methods={"GET"})
     */
    public function show(Components $component): Response
    {
        return $this->render('components/show.html.twig', [
            'component' => $component,
        ]);
    }

    /**
     * @Route("/{id}/edit", name="components_edit", methods={"GET","POST"})
     */
    public function edit(Request $request, Components $component): Response
    {
        $form = $this->createForm(ComponentsType::class, $component);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $this->getDoctrine()->getManager()->flush();

            return $this->redirectToRoute('components_index', [], Response::HTTP_SEE_OTHER);
        }

        return $this->renderForm('components/edit.html.twig', [
            'component' => $component,
            'form' => $form,
        ]);
    }

    /**
     * @Route("/{id}", name="components_delete", methods={"POST"})
     */
    public function delete(Request $request, Components $component): Response
    {
        if ($this->isCsrfTokenValid('delete'.$component->getId(), $request->request->get('_token'))) {
            $entityManager = $this->getDoctrine()->getManager();
            $entityManager->remove($component);
            $entityManager->flush();
        }

        return $this->redirectToRoute('components_index', [], Response::HTTP_SEE_OTHER);
    }
}

templates/Components/accessoires.html.twig
{% extends 'base.html.twig' %}

{% block title %}Accessoires{% endblock %}

{% block body %}
    <div class='row text-center components '>
        <div class="col-md-1  ">
        <input
            class="btn btn-outline-danger"
            type="button"
            value="Retour"
            onclick="history.back()">
    </div>
    <div class="col-md-10 mb-5 d-flex justify-content-center ">
        <h1 class='text-center'>Nos accessoires
                <br>
                recommandées
            </h1>
    </div>
        {% for Components in Components %}
            {% if Components.type == 'Accessory' %}
                <div class='col-sm-4 d-flex justify-content-center'>
                    <div class="card" style="width: 18rem;">
                        <img src="{{ Components.img }}" class="p-auto" alt="...">
                        <div class="card-body ">
                            <p class="card-title ">{{ Components.name }}</p>
                            <h5 class="card-text">{{ Components.price }}
                                €</h5>
                            <a href="{{ Components.url }}" target="_blank" class=" btn btn-primary">Voir plus</a>
                        </div>
                    </div>
                </div>
            {% endif %}
        {% endfor %}
    </div>
{% endblock %}

templates/Components/allimentations.html.twig
{% extends 'base.html.twig' %}

{% block title %}Allimentations{% endblock %}

{% block body %}
    <div class='row text-center components '>
        <div class="col-md-1  ">
        <input
            class="btn btn-outline-danger"
            type="button"
            value="Retour"
            onclick="history.back()">
    </div>
    <div class="col-md-10 mb-5 d-flex justify-content-center ">
 <h1 class='text-center'>Nos allimentations
                <br>
                recommandées
            </h1>    </div>
        {% for Components in Components %}
            {% if Components.type == 'Powersupply' %}
                <div class='col-sm-4 d-flex justify-content-center'>
                    <div class="card" style="">
                        <img src="{{ Components.img }}" class="p-auto" alt="...">
                        <div class="card-body ">
                            <p class="card-title ">{{ Components.name }}</p>
                            <h5 class="card-text">{{ Components.price }}
                                €</h5>
                            <a href="{{ Components.url }}" target="_blank" class=" btn btn-primary">Voir plus</a>
                        </div>
                    </div>
                </div>
            {% endif %}
        {% endfor %}
    </div>
{% endblock %}

templates/Components/cartesmere.html.twig
{% extends 'base.html.twig' %}

{% block title %}Cartes mère{% endblock %}

{% block body %}
    <div class='row text-center components '>
        <div class="col-md-1  ">
        <input
            class="btn btn-outline-danger"
            type="button"
            value="Retour"
            onclick="history.back()">
    </div>
    <div class="col-md-10 mb-5 d-flex justify-content-center ">
        <h1 class='text-center'>Nos processeurs<br>recommandées</h1>
    </div>
        {% for Components in Components %}
            {% if Components.type == 'Motherboard' %}
                <div class='col-sm-4 d-flex justify-content-center'>
                    <div class="card" style="width: 18rem;">
                        <img src="{{ Components.img }}" class="p-auto" alt="...">
                        <div class="card-body ">
                            <p class="card-title ">{{ Components.name }}</p>
                            <h5 class="card-text">{{ Components.price }}
                                €</h5>
                            <a href="{{ Components.url }}" target="_blank" class=" btn btn-primary">Voir plus</a>
                        </div>
                    </div>
                </div>
            {% endif %}
        {% endfor %}
    </div>
{% endblock %}

templates/Components/processeur.html.twig
{% extends 'base.html.twig' %}

{% block title %}Cpu{% endblock %}

{% block body %}
<div class='row text-center components '>
  <div class="col-md-1  ">
        <input
            class="btn btn-outline-danger"
            type="button"
            value="Retour"
            onclick="history.back()">
    </div>
    <div class="col-md-10 mb-5 d-flex justify-content-center ">
        <h1 class='text-center'>Nos processeurs<br>recommandées</h1>
    </div>


        {% for Components in Components %}
            {% if Components.type == 'Cpu' %}
                <div class='col-sm-4 d-flex justify-content-center'>
                    <div class="card" style="width: 18rem;">
                        <img src="{{ Components.img }}" class="p-auto" alt="...">
                        <div class="card-body ">
                            <p class="card-title ">{{ Components.name }}</p>
                            <h5 class="card-text">{{ Components.price }}
                                €</h5>
                            <a href="{{ Components.url }}" target="_blank" class=" btn btn-primary">Voir plus</a>
                        </div>
                    </div>
                </div>
            {% endif %}
        {% endfor %}
    </div>

    {# <div class="card">
  
    <a href="#!">
      <div class="mask" style="background-color: rgba(251, 251, 251, 0.15);"></div>
    </a>
  </div>
  <div class="card-body">
    <h5 class="card-title">Card title</h5>
    <p class="card-text">
      Some quick example text to build on the card title and make up the bulk of the
      card's content.
    </p>
    <a href="#!" class="btn btn-primary">Button</a>
  </div>
</div> #}
{% endblock %}

templates/Components/ram.html.twig
{% extends 'base.html.twig' %}

{% block title %}Ram{% endblock %}

{% block body %}
    <div class='row text-center components '>

        <div class="col-md-1  ">
        <input
            class="btn btn-outline-danger"
            type="button"
            value="Retour"
            onclick="history.back()">
    </div>
    <div class="col-md-10 mb-5 d-flex justify-content-center ">
        <h1 class='text-center'>Nos processeurs<br>recommandées</h1>
    </div>
        {% for Components in Components %}
            {% if Components.type == 'Ram' %}
                <div class='col-sm-4 d-flex justify-content-center'>
                    <div class="card" style="width: 18rem;">
                        <img src="{{ Components.img }}" class="p-auto" alt="...">
                        <div class="card-body ">
                            <p class="card-title ">{{ Components.name }}</p>
                            <h5 class="card-text">{{ Components.price }}
                                €</h5>
                            <a href="{{ Components.url }}" target="_blank" class=" btn btn-primary">Voir plus</a>
                        </div>
                    </div>
                </div>
            {% endif %}
        {% endfor %}
    </div>
{% endblock %}

templates/Components/rig.html.twig
{% extends 'base.html.twig' %}

{% block title %}Structures{% endblock %}

{% block body %}

        <div class="col-md-1  ">
        <input
            class="btn btn-outline-danger"
            type="button"
            value="Retour"
            onclick="history.back()">
    </div>
    <div class="col-md-10 mb-5 d-flex justify-content-center ">
        <h1 class='text-center'>Nos processeurs<br>recommandées</h1>
    </div>
        {% for Components in Components %}
            {% if Components.type == 'Rig' %}
                <div class='col-sm-4 d-flex justify-content-center'>
                    <div class="card" style="width: 18rem;">

                        <img src="{{ Components.img }}" class="p-auto" alt="...">
                        <div class="card-body ">

                            <p class="card-title ">{{ Components.name }}</p>
                            <h5 class="card-text">{{ Components.price }}
                                €</h5>
                            <a href="{{ Components.url }}" target="_blank" class=" btn btn-primary">Voir plus</a>
                        </div>
                    </div>
                </div>
            {% endif %}
        {% endfor %}
    </div>
{% endblock %}

templates/Components/stockage.html.twig
{% extends 'base.html.twig' %}

{% block title %}Stockage{% endblock %}

{% block body %}
<div class='row text-center components '>

    <div class="col-md-1  ">
        <input
            class="btn btn-outline-danger"
            type="button"
            value="Retour"
            onclick="history.back()">
    </div>
    <div class="col-md-10 mb-5 d-flex justify-content-center ">
        <h1 class='text-center'>Nos processeurs<br>recommandées</h1>
    </div>
    
     {% for Components in Components %}
     {% if Components.type == 'Storage' %} 
    <div class='col-sm-4 d-flex justify-content-center'>
        <div class="card" style="width: 18rem;">
          <img src="{{ Components.img }}" class="p-auto" alt="...">
          <div class="card-body ">
            <p class="card-title ">{{ Components.name }}</p>
            <h5 class="card-text">{{ Components.price }} €</h5>
            <a href="{{ Components.url }}" target="_blank"  class=" btn btn-primary">Voir plus</a>
          </div>
        </div>
    </div>
      {% endif %}
      {% endfor %}
</div>
{% endblock %}